import React, { PureComponent } from 'react'

import Questions from './Questions.js'

import constants from '../constants.json'

class QuestionSearchResult extends PureComponent {
  render () {
    const { data, searchTerm, onChange, deleteQuestion } = this.props

    let subjs = []
    let results = -1

    const countReducer = (acc, subj) => {
      return acc + subj.Questions.length
    }

    if (searchTerm) {
      subjs = data.Subjects.reduce((acc, subj) => {
        const resultQuestions = subj.Questions.reduce((qacc, question) => {
          const keys = [ 'Q', 'A', 'data' ]
          keys.some((key) => {
            if (typeof question[key] !== 'string') {
              return false
            }
            if (question[key] && question[key].toLowerCase().includes(searchTerm.toLowerCase())) {
              qacc.push(question)
              return true
            }
          })
          return qacc
        }, [])
        if (resultQuestions.length > 0) {
          acc.push({
            Name: subj.Name,
            Questions: resultQuestions,
            ind: subj.ind
          })
        }
        return acc
      }, [])
      results = subjs.reduce(countReducer, 0)
    } else {
      results = data.Subjects.reduce(countReducer, 0)
    }

    const renderCount = () => {
      return (
        <div>
          {searchTerm ? '' : 'Kezdj el írni kereséshez!'} {results} {searchTerm ? 'találat' : 'kérdés' } {searchTerm ? subjs.length : data.Subjects.length} tárgy
        </div>
      )
    }

    if (results > constants.maxQuestionsToRender) {
      return renderCount()
    } else {
      return (
        <div >
          <div>
            {renderCount()}
          </div>
          <div>
            <Questions
              deleteQuestion={deleteQuestion}
              subjs={subjs}
              onChange={onChange}
            />
          </div>
        </div>
      )
    }
  }
}

export default QuestionSearchResult
