import React, { useState } from 'react'

import LoadingIndicator from '../components/LoadingIndicator.js'
import QuestionSearchResult from '../components/QuestionSearchResult.js'

import styles from './questionView.module.css'

export default function questionView (props) {
  const { data, onChange, deleteQuestion } = props
  const [searchTerm, setSearchTerm] = useState('')

  if (data) {
    return (
      <div>
        <div className={styles.searchContainer}>
          <input
            placeholder='Keresés...'
            className={styles.searchBar}
            type='text'
            value={searchTerm}
            onChange={(e) => { setSearchTerm(e.target.value) }}
          />
          <button
            onClick={() => {
              setSearchTerm('')
            }}
            className={styles.clearButton}
          >
             X
          </button>
        </div>
        <hr />
        <div>
          <QuestionSearchResult
            onChange={onChange}
            data={data}
            searchTerm={searchTerm}
            deleteQuestion={deleteQuestion}
          />
        </div>
      </div>
    )
  } else {
    return (
      <LoadingIndicator />
    )
  }
}
